﻿Imports System.Linq
Imports SterlingRecipes.Models
Imports Wintellect.Sterling
Imports Wintellect.Sterling.Database

''' <summary>
'''     Generic definition for an identity trigger based on integers
''' </summary>
''' <typeparam name="T">The type</typeparam>
Public Class IdentityTrigger(Of T As {Class, IBaseModel, New})
    Inherits BaseSterlingTrigger(Of T, Integer)
    Private Shared _idx As Integer = 1

    Public Sub New(ByVal database As ISterlingDatabaseInstance)
        ' if a record exists, set it to the highest value plus 1
        If database.Query(Of T, Integer)().Any() Then
            _idx = database.Query(Of T, Integer)().Max(Function(key) key.Key) + 1
        End If
    End Sub

    ''' <summary>
    '''  See if we need to provide an id
    ''' </summary>
    ''' <param name="instance">Instance to check</param>
    ''' <returns>True if we're good to save</returns>
    Public Overrides Function BeforeSave(ByVal instance As T) As Boolean
        If instance.Id < 1 Then
            instance.Id = _idx
            _idx += 1
        End If

        Return True
    End Function

    Public Overrides Sub AfterSave(ByVal instance As T)
        Return
    End Sub

    Public Overrides Function BeforeDelete(ByVal key As Integer) As Boolean
        Return True
    End Function
End Class