﻿Imports System
Imports System.IO
Imports Wintellect.Sterling.Exceptions
Imports Wintellect.Sterling.Serialization

''' <summary>
'''     Serialier that handles types and their derivatives
''' </summary>
Public Class TypeSerializer
    Inherits BaseSerializer
    ''' <summary>
    '''     Return true if this serializer can handle the object, i.e. if it
    '''     can be cast to type
    ''' </summary>
    ''' <param name="targetType">The target</param>
    ''' <returns>True if it can be serialized</returns>
    Public Overrides Function CanSerialize(ByVal targetType As Type) As Boolean
        Return GetType(Type).IsAssignableFrom(targetType)
    End Function
    Public Sub dd(ByVal kk As BaseSerializer)

    End Sub

    ''' <summary>
    '''     Serialize the object
    ''' </summary>
    ''' <param name="target">The target</param>
    ''' <param name="writer">The writer</param>
    Public Overrides Sub Serialize(ByVal target As Object, ByVal writer As BinaryWriter)
        Dim type = TryCast(target, Type)

        ' this is important
        If type Is Nothing Then
            Throw New SterlingSerializerException(Me, target.GetType())
        End If

        ' we need this 
        If type.AssemblyQualifiedName Is Nothing Then
            Throw New SterlingSerializerException(Me, target.GetType())
        End If

        writer.Write(type.AssemblyQualifiedName)
    End Sub

    ''' <summary>
    '''     Deserialize the object
    ''' </summary>
    ''' <param name="type">The type of the object</param>
    ''' <param name="reader">A reader to deserialize from</param>
    ''' <returns>The deserialized object</returns>
    Public Overrides Function Deserialize(ByVal type As Type, ByVal reader As BinaryReader) As Object
        Return type.GetType(reader.ReadString())
    End Function
End Class