﻿Imports System.Collections.Generic
Imports System.Collections.ObjectModel
Imports SterlingRecipes.Models
Imports UltraLight.MVVM.Contracts

Namespace Contracts
    ''' <summary>
    '''     Contract for the recipe view model
    ''' </summary>
    Public Interface IRecipeViewModel
        Inherits IViewModel
        Sub EditRecipe(ByVal recipe As RecipeModel)

        Sub AddRecipe()

        ReadOnly Property RecipeName() As String

        ReadOnly Property Title() As String

        ReadOnly Property RecipeCategory() As CategoryModel

        ReadOnly Property Categories() As IEnumerable(Of CategoryModel)

        ReadOnly Property Ingredients() As ObservableCollection(Of IngredientModel)

        ReadOnly Property SelectedIngredient() As IngredientModel

        ReadOnly Property Instructions() As String

        ReadOnly Property AddIngredient() As IActionCommand(Of Object)
        ReadOnly Property DeleteIngredient() As IActionCommand(Of IngredientModel)
        ReadOnly Property SaveRecipe() As IActionCommand(Of Object)
        ReadOnly Property Cancel() As IActionCommand(Of Object)
    End Interface
End Namespace