﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports SterlingRecipes.Contracts
Imports SterlingRecipes.Models
Imports UltraLight.MVVM.Contracts

Namespace SampleData
    ''' <summary>
    '''     Design data for ingredients
    ''' </summary>
    Public Class DesignIngredientViewModel
        Implements IIngredientViewModel
        Public ReadOnly Property Title() As String Implements IIngredientViewModel.Title
            Get
                Return "Edit Ingredient"
            End Get
        End Property

        Public ReadOnly Property Units() As String Implements IIngredientViewModel.Units
            Get
                Return "4.5"
            End Get
        End Property

        Public Sub AddIngredient() Implements IIngredientViewModel.AddIngredient
            Return
        End Sub

        ''' <summary>
        '''     To to visual state 
        ''' </summary>
        Public Property GoToVisualState() As Action(Of String, Boolean) Implements IViewModel.GoToVisualState

        ''' <summary>
        '''     Back request
        ''' </summary>
        ''' <returns>Used to process a back request. Return true to cancel.</returns>
        Public Function CancelBackRequest() As Boolean Implements IViewModel.CancelBackRequest
            Return False
        End Function


        Public Sub EditIngredient(ByVal ingredient As IngredientModel) Implements IIngredientViewModel.EditIngredient
            Return
        End Sub

        Public ReadOnly Property FoodText() As String Implements IIngredientViewModel.FoodText
            Get
                Return "almond"
            End Get
        End Property

        Public ReadOnly Property Food() As IEnumerable(Of FoodModel) Implements IIngredientViewModel.Food
            Get
                Return New List(Of FoodModel) From {
                 New FoodModel With {.Id = 1, .FoodName = "Almond Butter"},
                 New FoodModel With {.Id = 2, .FoodName = "Almond Milk"}}
            End Get
        End Property

        Public ReadOnly Property SelectedFood() As FoodModel Implements IIngredientViewModel.SelectedFood
            Get
                Return Food.First()
            End Get
        End Property

        Public ReadOnly Property Measures() As IEnumerable(Of MeasureModel) Implements IIngredientViewModel.Measures
            Get
                Return New List(Of MeasureModel) From {
                 New MeasureModel With {.Id = 1, .Abbreviation = "oz", .FullMeasure = "Ounce"},
                 New MeasureModel With {.Id = 2, .Abbreviation = "cup", .FullMeasure = "Cup"},
                 New MeasureModel With {.Id = 3, .Abbreviation = "tsp", .FullMeasure = "Teaspoon"}}
            End Get
        End Property

        Public ReadOnly Property SelectedMeasure() As MeasureModel Implements IIngredientViewModel.SelectedMeasure
            Get
                Return Measures.First()
            End Get
        End Property

        Public ReadOnly Property SaveIngredient() As IActionCommand(Of Object) Implements IIngredientViewModel.SaveIngredient
            Get
                Return Nothing
            End Get
        End Property

        Public ReadOnly Property Cancel() As IActionCommand(Of Object) Implements IIngredientViewModel.Cancel
            Get
                Return Nothing
            End Get
        End Property

        Public ReadOnly Property AddFood() As IActionCommand(Of Object) Implements IIngredientViewModel.AddFood
            Get
                Return Nothing
            End Get
        End Property

        Public ReadOnly Property FoodSearch() As IActionCommand(Of Object) Implements IIngredientViewModel.FoodSearch
            Get
                Return Nothing
            End Get
        End Property

        Public Property GoBack() As Action Implements IViewModel.GoBack

        Public Property Dialog() As IDialog Implements IViewModel.Dialog
        Public Property RequestNavigation() As Action(Of String) Implements IViewModel.RequestNavigation
        Public ReadOnly Property ApplicationBindings() As IEnumerable(Of IActionCommand(Of Object)) Implements IViewModel.ApplicationBindings
            Get
                Return Nothing
            End Get
        End Property
    End Class
End Namespace