﻿Imports System
Imports System.Collections.Generic
Imports System.Collections.ObjectModel
Imports System.Linq
Imports SterlingRecipes.Contracts
Imports SterlingRecipes.Models
Imports UltraLight.MVVM.Contracts

Namespace SampleData
    ''' <summary>
    '''     Design time recipe data
    ''' </summary>
    Public Class DesignRecipeViewModel
        Implements IRecipeViewModel
        Public Sub EditRecipe(ByVal recipe As RecipeModel) Implements IRecipeViewModel.EditRecipe
            Return
        End Sub

        Public Sub AddRecipe() Implements IRecipeViewModel.AddRecipe
            Return
        End Sub

        Public ReadOnly Property RecipeName() As String Implements IRecipeViewModel.RecipeName
            Get
                Return "Grandma's Chicken Soup"
            End Get
        End Property

        ''' <summary>
        '''     Back request
        ''' </summary>
        ''' <returns>Used to process a back request. Return true to cancel.</returns>
        Public Function CancelBackRequest() As Boolean Implements IViewModel.CancelBackRequest
            Return False
        End Function


        ''' <summary>
        '''     To to visual state 
        ''' </summary>
        Public Property GoToVisualState() As Action(Of String, Boolean) Implements IViewModel.GoToVisualState

        Public ReadOnly Property Title() As String Implements IRecipeViewModel.Title
            Get
                Return "Edit Recipe"
            End Get
        End Property

        Public ReadOnly Property Categories() As IEnumerable(Of CategoryModel) Implements IRecipeViewModel.Categories
            Get
                Return DesignMainViewModel.CategoryData
            End Get
        End Property

        Public ReadOnly Property RecipeCategory() As CategoryModel Implements IRecipeViewModel.RecipeCategory
            Get
                Return DesignMainViewModel.CategoryData.First()
            End Get
        End Property

        Public ReadOnly Property Ingredients() As ObservableCollection(Of IngredientModel) Implements IRecipeViewModel.Ingredients
            Get
                Dim observable = New ObservableCollection(Of IngredientModel) From {
                 New IngredientModel With {.Id = 1, .Amount =
                 New MeasureAmountModel With {.Units = 4, .Measure =
                 New MeasureModel With {.Id = 1, .Abbreviation = "oz", .FullMeasure = "Ounces"}}, .Food =
                 New FoodModel With {.Id = 1, .FoodName = "Chicken"}, .Order = 1},
                 New IngredientModel With {.Id = 2, .Amount =
                 New MeasureAmountModel With {.Units = 8, .Measure =
                 New MeasureModel With {.Id = 2, .Abbreviation = "cup", .FullMeasure = "Cup"}}, .Food =
                 New FoodModel With {.Id = 2, .FoodName = "Broth"}, .Order = 1}}
                Return observable
            End Get
        End Property

        Public ReadOnly Property SelectedIngredient() As IngredientModel Implements IRecipeViewModel.SelectedIngredient
            Get
                Return Ingredients(0)
            End Get
        End Property

        Public ReadOnly Property Instructions() As String Implements IRecipeViewModel.Instructions
            Get
                Return "Mix all of that stuff together. Pour in the broth (it's good and tasty). Add the chicken. Heat it up and wait until it tastes great."
            End Get
        End Property

        Public ReadOnly Property AddIngredient() As IActionCommand(Of Object) Implements IRecipeViewModel.AddIngredient
            Get
                Return Nothing
            End Get
        End Property

        Public ReadOnly Property DeleteIngredient() As IActionCommand(Of IngredientModel) Implements IRecipeViewModel.DeleteIngredient
            Get
                Return Nothing
            End Get
        End Property

        Public ReadOnly Property SaveRecipe() As IActionCommand(Of Object) Implements IRecipeViewModel.SaveRecipe
            Get
                Return Nothing
            End Get
        End Property

        Public ReadOnly Property Cancel() As IActionCommand(Of Object) Implements IRecipeViewModel.Cancel
            Get
                Return Nothing
            End Get
        End Property

        Public Property GoBack() As Action Implements IViewModel.GoBack

        Public Property Dialog() As IDialog Implements IViewModel.Dialog
        Public Property RequestNavigation() As Action(Of String) Implements IViewModel.RequestNavigation
        Public ReadOnly Property ApplicationBindings() As IEnumerable(Of IActionCommand(Of Object)) Implements IViewModel.ApplicationBindings
            Get
                Return Nothing
            End Get
        End Property
    End Class
End Namespace