﻿Imports System
Imports System.Collections.Generic
Imports SterlingRecipes.Contracts
Imports UltraLight.MVVM.Contracts

Namespace SampleData
    ''' <summary>
    '''     Design time text data
    ''' </summary>
    Public Class DesignTextEditorViewModel
        Implements ITextEditorViewModel
        Public Sub BeginEdit(ByVal title As String, ByVal text As String) Implements ITextEditorViewModel.BeginEdit
            Return
        End Sub

        Public ReadOnly Property Title() As String Implements ITextEditorViewModel.Title
            Get
                Return "Instructions"
            End Get
        End Property

        Public ReadOnly Property Text() As String Implements ITextEditorViewModel.Text
            Get
                Return "Remove crust and flatten bread with rolling pin by rolling bread on cutting board. Spread a thin layer of almond butter and jam onto bread. Roll up slice of bread to look like a sushi roll. Cut bread into four bite-size pieces using a serrated knife."
            End Get
        End Property

        ''' <summary>
        '''     To to visual state 
        ''' </summary>
        Public Property GoToVisualState() As Action(Of String, Boolean) Implements IViewModel.GoToVisualState

        ''' <summary>
        '''     Back request
        ''' </summary>
        ''' <returns>Used to process a back request. Return true to cancel.</returns>
        Public Function CancelBackRequest() As Boolean Implements IViewModel.CancelBackRequest
            Return False
        End Function

        ''' <summary>
        '''     Navigation 
        ''' </summary>
        Public Property GoBack() As Action Implements IViewModel.GoBack

        ''' <summary>
        '''     Dialog 
        ''' </summary>
        Public Property Dialog() As IDialog Implements IViewModel.Dialog

        ''' <summary>
        '''     Navigation request
        ''' </summary>
        Public Property RequestNavigation() As Action(Of String) Implements IViewModel.RequestNavigation

        ''' <summary>
        '''     Commands to bind to application bar buttons
        ''' </summary>
        Public ReadOnly Property ApplicationBindings() As IEnumerable(Of IActionCommand(Of Object)) Implements IViewModel.ApplicationBindings
            Get
                Return Nothing
            End Get
        End Property
    End Class
End Namespace