﻿Imports System.Windows
Imports SterlingRecipes.Contracts
Imports SterlingRecipes.Messages
Imports SterlingRecipes.Models
Imports UltraLight.MVVM

Namespace Views
    Partial Public Class IngredientsList
        Public Sub New()
            InitializeComponent()
            Me.BindToViewModel(Of IRecipeViewModel)(LayoutRoot)
        End Sub

        Protected Overrides Sub OnNavigatedTo(ByVal e As System.Windows.Navigation.NavigationEventArgs)
            LayoutRoot.ActivatePage(Of IRecipeViewModel)()
            MyBase.OnNavigatedTo(e)
        End Sub

        Protected Overrides Sub OnNavigatingFrom(ByVal e As System.Windows.Navigation.NavigatingCancelEventArgs)
            Me.DeactivatePage(Of IRecipeViewModel)()
            MyBase.OnNavigatingFrom(e)
        End Sub

        ''' <summary>
        '''     Delete click - go ahead and handle this directly via event aggregator
        ''' </summary>
        ''' <param name="sender">The button</param>
        ''' <param name="e">The arguments</param>
        Private Sub _ButtonClick(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim frameworkElement = TryCast(sender, FrameworkElement)

            If frameworkElement Is Nothing Then
                Return
            End If

            Dim ingredientModel = TryCast(frameworkElement.DataContext, IngredientModel)

            If ingredientModel Is Nothing Then
                Return
            End If

            UltraLightLocator.EventAggregator.Publish(IngredientMessage.Create(IngredientAction.Remove, ingredientModel))
        End Sub
    End Class
End Namespace