﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports UltraLight.MVVM.Contracts

''' <summary>
'''     Base view model for data-binding
''' </summary>
Public MustInherit Class BaseViewModel
    Inherits BaseNotify
    Implements IViewModel
    ''' <summary>
    '''     True if in the designer
    ''' </summary>
    Protected ReadOnly Property InDesigner() As Boolean
        Get
            Return DesignerProperties.IsInDesignTool
        End Get
    End Property

    ''' <summary>
    '''     To to visual state 
    ''' </summary>
    Public Overridable Property GoToVisualState() As Action(Of String, Boolean) Implements IViewModel.GoToVisualState

    ''' <summary>
    '''     Back request
    ''' </summary>
    ''' <returns>Used to process a back request. Return true to cancel.</returns>
    Public Overridable Function CancelBackRequest() As Boolean Implements IViewModel.CancelBackRequest
        Return False
    End Function

    ''' <summary>
    '''     Navigation go back
    ''' </summary>
    Public Property GoBack() As Action Implements IViewModel.GoBack

    ''' <summary>
    '''     Dialog
    ''' </summary>
    Public Property Dialog() As IDialog Implements IViewModel.Dialog

    ''' <summary>
    '''     Request a navigation event
    ''' </summary>
    Public Property RequestNavigation() As Action(Of String) Implements IViewModel.RequestNavigation

    ''' <summary>
    '''     For pages, the list of commands to bind to application bar buttons
    ''' </summary>
    Public MustOverride ReadOnly Property ApplicationBindings() As IEnumerable(Of IActionCommand(Of Object)) Implements IViewModel.ApplicationBindings

End Class