﻿Imports System
Imports System.Windows.Input

Namespace Contracts
    ''' <summary>
    '''     Typed action command
    ''' </summary>
    ''' <typeparam name="T">The type to act against</typeparam>
    Public Interface IActionCommand(Of T)
        Inherits IActionCommand
        ''' <summary>
        '''     Override the action
        ''' </summary>
        ''' <param name="action"></param>
        Sub OverrideAction(ByVal action As Action(Of T))
    End Interface

    ''' <summary>
    '''     Basic action command
    ''' </summary>
    Public Interface IActionCommand
        Inherits ICommand
        ''' <summary>
        '''     True if the original command has been overridden
        ''' </summary>
        Property Overridden() As Boolean

        ''' <summary>
        '''     Raise the execute changed event
        ''' </summary>
        Sub RaiseCanExecuteChanged()
    End Interface
End Namespace