﻿Namespace Contracts
    ''' <summary>
    '''     Event aggregator for generic pub/sub messaging
    ''' </summary>
    Public Interface IEventAggregator
        ''' <summary>
        '''     Publish an event
        ''' </summary>
        ''' <typeparam name="TEvent">The type of the event to publish</typeparam>
        ''' <param name="sampleEvent">The event data</param>
        Sub Publish(Of TEvent)(ByVal sampleEvent As TEvent)

        ''' <summary>
        '''     Get a handle to subscribe/listen to an event
        ''' </summary>
        ''' <typeparam name="TEvent">The event type to listen for</typeparam>
        ''' <param name="subscriber">The subscriber</param>
        Sub Subscribe(Of TEvent)(ByVal subscriber As IEventSink(Of TEvent))

        ''' <summary>
        '''     Get a handle to subscribe/listen to an event
        ''' </summary>
        ''' <typeparam name="TEvent">The event type to listen for</typeparam>
        ''' <param name="subscriber">The subscriber</param>
        Sub SubscribeOnDispatcher(Of TEvent)(ByVal subscriber As IEventSink(Of TEvent))

        ''' <summary>
        '''     Unsubscriber
        ''' </summary>
        ''' <typeparam name="TEvent"></typeparam>
        ''' <param name="unsubscriber"></param>
        Sub Unsubscribe(Of TEvent)(ByVal unsubscriber As IEventSink(Of TEvent))
    End Interface
End Namespace