﻿Imports System
Imports System.Collections.Generic

Namespace Contracts
    ''' <summary>
    '''     Interface for view models
    ''' </summary>
    Public Interface IViewModel
        ''' <summary>
        '''     To to visual state 
        ''' </summary>
        Property GoToVisualState() As Action(Of String, Boolean)

        ''' <summary>
        '''     Back request
        ''' </summary>
        ''' <returns>Used to process a back request. Return true to cancel.</returns>
        Function CancelBackRequest() As Boolean

        ''' <summary>
        '''     Navigation 
        ''' </summary>
        Property GoBack() As Action

        ''' <summary>
        '''     Dialog 
        ''' </summary>
        Property Dialog() As IDialog

        ''' <summary>
        '''     Navigation request
        ''' </summary>
        Property RequestNavigation() As Action(Of String)

        ''' <summary>
        '''     Commands to bind to application bar buttons
        ''' </summary>
        ReadOnly Property ApplicationBindings() As IEnumerable(Of IActionCommand(Of Object))
    End Interface
End Namespace