﻿Imports System

''' <summary>
'''     An entry in the event table to keep track of references
''' </summary>
Public Class EventEntry
    Private _guid As Guid = Guid.NewGuid()

    Public Property ExecuteOnDispatcher() As Boolean
    Public Property Subscriber() As WeakReference

    Public Shared Function Create(ByVal executeOnDispatcher As Boolean, ByVal subscriber As WeakReference) As EventEntry
        Return New EventEntry With {.ExecuteOnDispatcher = executeOnDispatcher, .Subscriber = subscriber}
    End Function

    Public Overloads Overrides Function Equals(ByVal obj As Object) As Boolean
        '       
        ' See the full list of guidelines at
        '   http://go.microsoft.com/fwlink/?LinkID=85237  
        ' and also the guidance for operator== at
        '   http://go.microsoft.com/fwlink/?LinkId=85238
        '

        If obj Is Nothing OrElse Me.GetType() IsNot obj.GetType() Then
            Return False
        End If

        Return (CType(obj, EventEntry))._guid.Equals(_guid)
    End Function

    Public Overrides Function GetHashCode() As Integer
        Return _guid.GetHashCode()
    End Function

End Class